﻿using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using System.Data.SqlClient;
using com.WizardWu.DAL;

public partial class _Default : System.Web.UI.Page 
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    // 上傳圖檔
    protected void btnUpload_Click(object sender, EventArgs e)
    {
        if (FileUpload1.HasFile)
        {
            Response.Write("上傳的圖檔名稱: " + FileUpload1.FileName + "<br>");
            Response.Write("上傳的圖檔大小: " + FileUpload1.PostedFile.ContentLength + " Byte<br>");
            Response.Write("上傳的圖檔格式: " + FileUpload1.PostedFile.ContentType + "<p>");
            byte[] byteImageLength = FileUpload1.FileBytes;

            if (byteImageLength.Length < 3000000)   // 可在這限制上傳圖檔的大小，單位：位元組(Byte)
            {
                try
                {
                    DbAccess dba = new DbAccess();
                    string strSql = "INSERT INTO table1 (ImageName, ImageData) VALUES (@ImageName, @ImageData)";
                    dba.UploadImageToDB(strSql, FileUpload1.FileName, byteImageLength);

                    Response.Write("<font color='red'>圖檔上傳成功。" + "</font><br>");
                }
                catch (Exception ex)
                {
                    Response.Write("<font color='red'>圖檔上傳失敗，錯誤為: " + ex.ToString() + "</font><br>");
                }
            }
            else
            {
                Response.Write("<font color='red'>檔太大~~<br>不可超過 3,000,000 位元組，請重新選擇圖檔" + "</font><br>");
            }
        }
        else
        {
            Response.Write("<font color='red'>請選擇一個圖檔" + "</font><br>");
        }
    }


    // 讀取圖檔 (會先詢問使用者，要直接開啟還是另存新檔)
    protected void btnOpenAsk_Click(object sender, EventArgs e)
    {
        byte[] byteImageData = null;
        string strImageName = null;

        try
        {
            DbAccess dba = new DbAccess();
            string strSql = "SELECT ImageName, ImageData FROM table1 WHERE ID=@ID";
            byteImageData = dba.ReadImageFromDB(strSql, DropDownList1.SelectedValue, out strImageName);
            //Response.Write("開啟的圖檔名稱為：" + strImageName);  // 此行無法被執行到

            // 設定輸出格式，並寫入輸出資料流 (目前無法處理中文圖檔名)
            Response.HeaderEncoding = System.Text.Encoding.Default;
            Response.AddHeader("Content-Disposition", string.Format("attachment; filename={0}", strImageName));
            Response.BinaryWrite(byteImageData);
        }
        catch (Exception ex)
        {
            Response.Write("<font color='red'>圖檔開啟失敗，錯誤為: " + ex.ToString() + "</font><br>");
        }
    }


    // 讀取圖檔 (直接開啟在 Image 控制項中)
    protected void btnOpenDirectly_Click(object sender, EventArgs e)
    {
        try
        {
            // 圖片無法直接顯示在 Image 控制項中，必須透過中介的 ReadImage.aspx 頁面來讀取和呈現資料庫中的圖檔
            Image1.ImageUrl = "ReadImage.aspx?ID=" + DropDownList2.SelectedValue;
            lblImageName.Text = "<font color='red'>開啟的圖檔名稱為：" + DropDownList2.SelectedItem.Text + "</font>";
        }
        catch// (Exception ex)
        {
            //Response.Write("<font color='red'>圖檔開啟失敗，錯誤為: " + ex.ToString() + "</font><br>");
        }
    }


    // 重新繫結下拉選單
    protected void Button1_Click(object sender, EventArgs e)
    {
        DropDownList1.DataBind();
    }
    // 重新繫結下拉選單
    protected void Button2_Click(object sender, EventArgs e)
    {
        DropDownList2.DataBind();
    }

}
